/* ###################################### */
/* #                                    # */
/* #  Un compilateur pour le langage    # */
/* #        ALGO                        # */
/* #                                    # */
/* # Unite d'analyse syntaxique         # */
/* #                                    # */
/* # BRUNO Emmanuel 1998                # */
/* # bruno@univ-tln.fr                  # */
/* ###################################### */

#include <stdio.h>
#include <string.h>
#include "algo_syntaxique.h"

noeud facteur()
{
  noeud arbre_facteur,arbre_valeur;
  switch (lex_sym)
    {
    case s_ident: 
      arbre_facteur=creer_racine("identificateur");
      arbre_valeur=creer_racine(lex_val);
      arbre_facteur=ajoute_fils(arbre_facteur,arbre_valeur);
      lire_symbole();
      break;
    case s_reel: 
	arbre_facteur=creer_racine("reel");
	arbre_valeur=creer_racine(lex_val);
	arbre_facteur=ajoute_fils(arbre_facteur,arbre_valeur);
	lire_symbole();
	break;
    case s_entier: 
      arbre_facteur=creer_racine("entier");
      arbre_valeur=creer_racine(lex_val);
      arbre_facteur=ajoute_fils(arbre_facteur,arbre_valeur);
      lire_symbole();
      break;
    case s_parent_g:
	lire_symbole();
	arbre_facteur=creer_racine("parenthse");
	arbre_valeur=expression();
	if (lex_sym==s_parent_d) 
	  {
	    lire_symbole();
	    arbre_facteur=ajoute_fils(arbre_facteur,arbre_valeur);
	  }
	else
	  printf("Erreur: parenthse fermante manquante %d.\n",lex_sym);
	break;
    case s_non :
	lire_symbole();
	arbre_facteur=creer_racine("negation");
	arbre_valeur=facteur();
	arbre_facteur=ajoute_fils(arbre_facteur,arbre_valeur);
	break;
    }
  return arbre_facteur;
}

noeud terme()
{
  noeud arbre_terme,arbre_avant,arbre_facteur;
  short operateur;
  
  arbre_avant=NULL;
  arbre_terme=facteur();
  arbre_avant=arbre_terme;
  while ( 
	 (lex_sym == s_etoile) 
	 || (lex_sym == s_slash )
	 || (lex_sym == s_mod )
	 || (lex_sym == s_div )
	 || (lex_sym == s_et ) )
    {
      operateur=lex_sym;
      lire_symbole();
      arbre_facteur=facteur();
      switch (operateur) 
	{
	case s_etoile:{arbre_terme=creer_racine("Multiplier");break;}
	case s_slash:{arbre_terme=creer_racine("Diviser");break;}
	case s_mod:{arbre_terme=creer_racine("Modulo");break;}
	case s_div:{arbre_terme=creer_racine("Division entire");break;}
	case s_et:{arbre_terme=creer_racine("Et logique");break;}
	}
      arbre_terme=ajoute_fils(arbre_terme,arbre_avant);
      arbre_terme=ajoute_fils(arbre_terme,arbre_facteur);
      arbre_avant=arbre_terme;
    }
  return arbre_terme;
}

noeud expression_simple()
{
  short operateur;
  noeud arbre_expression_simple,arbre_terme2,arbre_avant;
  switch (lex_sym)
    {
    case s_plus:{lire_symbole();arbre_avant=terme();break;}
    case s_moins:{lire_symbole();arbre_avant=terme();break;}
    default: arbre_avant=terme();
    }
  arbre_expression_simple=arbre_avant;
  while ( (lex_sym == s_plus) 
	 || (lex_sym == s_moins )
	  || (lex_sym == s_ou ) )
    {
      operateur=lex_sym;
      lire_symbole();
      arbre_terme2=terme();
       switch (operateur) 
	{
	case s_plus:{arbre_expression_simple=creer_racine("Plus");break;}
	case s_moins:{arbre_expression_simple=creer_racine("Moins");break;}
	case s_ou:{arbre_expression_simple=creer_racine("Ou logique");break;}
	}
       arbre_expression_simple=ajoute_fils(arbre_expression_simple,arbre_avant);
       arbre_expression_simple=ajoute_fils(arbre_expression_simple,arbre_terme2);
       arbre_avant=arbre_expression_simple;
    }
	 
}

noeud expression()
{  
  return expression_simple();
}

void TP2_exercice1(char *fich)
{
  noeud arbre=NULL;
  lex_init(fich);
  lire_symbole();
  arbre=terme();
  affiche_arbre_syntaxique(arbre);
  lex_fin();
}

void TP2_exercice2(char *fich)
{
  noeud arbre=NULL;
  lex_init(fich);
  lire_symbole();
  arbre=expression_simple();
  affiche_arbre_syntaxique(arbre);
  lex_fin();
}

int main()
{
  //TP2_exercice1("terme.txt");
  TP2_exercice2("expression-simple.txt");
  return 1;
}
